﻿<script type="text/javascript">
	function getVerticalScrollPosition() { 
		return document.body.scrollTop.toString(); 
	}

	function setVerticalScrollPosition(position) { 
		document.body.scrollTop = position; 
	}
	
	function getHorizontalScrollPosition() { 
		return document.body.scrollLeft.toString();
	}

	function setHorizontalScrollPosition(position) {
		document.body.scrollLeft = position;
	}

	/*  */
	function getDocHeight() {
		var D = document;
		return Math.max(
			Math.max(D.body.scrollHeight, D.documentElement.scrollHeight),
			Math.max(D.body.offsetHeight, D.documentElement.offsetHeight),        
			Math.max(D.body.clientHeight, D.documentElement.clientHeight)
		);
	}


	/*------------------------------------------------------------------------
	 * FUNCTION getAnchorPosition -- find page-relative coordinates of the
	 *                               named anchor
	 */
	function getAnchorPosition(anchorname, byName)
	{
		// This function will return an Object with x and y properties
		var useWindow = false;
		var coordinates = new Object();
		var elem;

		if (byName) {
			elem = document.getElementsByName(anchorname);
			elem = elem[0];
		} else {
			elem = document.getElementById(anchorname);
		}
		if (!elem) {
			// No object.
			coordinates.x = 0;
			coordinates.y = 0;
		} else {
			var x = elem.offsetLeft;
			var y = elem.offsetTop;
			while ((elem = elem.offsetParent) != null) {
				x += elem.offsetLeft;
				y += elem.offsetTop;
			}
			coordinates.x = x;
			coordinates.y = y;
		}
		return coordinates;

	} /* getAnchorPosition */

	/*------------------------------------------------------------------------
	 * FUNCTION getAnchorPositionPageOffsetTop -- find the page-relative top
	 *                      offset of the given element
	 */
	function getAnchorPositionPageOffsetTop(elem)
	{
		var top = elem.offsetTop;
		while ((elem = elem.offsetParent) != null) {
			top += elem.offsetTop;
		}
		return top;

	} /* getAnchorPositionPageOffsetTop */

	/*------------------------------------------------------------------------
	 * FUNCTION gotoElement -- scroll page to show the identified element
	 */
	function gotoElement(element, container)
	{
		var y = 0;
		if (element != '') {
			if (container == 'scriptures') {
				// Scroll to a scripture
				y = getAnchorPositionPageOffsetTop(document.getElementById(element));
			} else {
				if (element.substring(0, 8) == 'footnote') {
					// Scroll to a footnote
					var cs = getAnchorPosition(element, true);
					y = cs.y;
				} else {
					// Scroll to a citation in a talk
					var cs = getAnchorPosition(element, false);
					y = cs.y;
				}
			}

			var ap = getAnchorPosition(container, false);
			var offset = ap.y;
			var distance = y - offset;

			var con = document.getElementById(container);
			con.scrollTop = distance;
		}
	} /* gotoElement */

	function scrollToHash(hashTag) 
	{
		try
		{
			window.location.hash = hashTag;
		}
		catch (err)
		{
			try
			{
				window.location.hash = '#' + hashTag;
			}
			catch(err)
			{
			}
		}
	}
</script>